Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data

Imports Syncfusion.Windows.Forms.Diagram
Imports Syncfusion.Windows.Forms.Diagram.Controls

Namespace Nested_Symbols
	''' <summary>
	''' Summary description for Form1.
	''' </summary>
	Public Class Form1 : Inherits System.Windows.Forms.Form
		Private paletteGroupView1 As Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView
		Private WithEvents diagram1 As Syncfusion.Windows.Forms.Diagram.Controls.Diagram
		Private textBox1 As System.Windows.Forms.TextBox
		Private symbol As Syncfusion.Windows.Forms.Diagram.Symbol
		''' <summary>
		''' Required designer variable.
		''' </summary>
		Private components As System.ComponentModel.Container = Nothing

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()

			'
			' TODO: Add any constructor code after InitializeComponent call
			'
		End Sub
		Protected Overrides Sub OnLoad(ByVal e As EventArgs)
			MyBase.OnLoad(e)

			Me.LoadSymbolPalette()
		End Sub

		' Create a SymbolModel for the custom MySymbol and add it to the PaletteGroupView control
		Protected Sub LoadSymbolPalette()
			' Create a SymbolPalette for the PaletteGroupView control
			Me.paletteGroupView1.Palette = New SymbolPalette()

			' Initialize a SymbolModel for the custom Symbol class
			Dim mysymbolmodel As SymbolModel = Me.paletteGroupView1.Palette.AddSymbol("MySymbol")
			mysymbolmodel.PlugInClass = "Nested_Symbols.MySymbol"
			mysymbolmodel.PlugInAssembly = GetType(Form1).Assembly.FullName
			mysymbolmodel.SmallIcon = New Bitmap("..\..\res\symbol_small.bmp")
			mysymbolmodel.LargeIcon = New Bitmap("..\..\res\symbol_large.bmp")

			' Create a PaletteGroupView item to represent the SymbolModel and add it to the PaletteGroupView
			Dim imageIdx As Integer = 0
			Dim lgImageIdx As Integer = 0
			Dim smImageIdx As Integer = 0
			If Not mysymbolmodel.SmallIcon Is Nothing Then
				smImageIdx = Me.paletteGroupView1.AddSmallIcon(mysymbolmodel.SmallIcon)
			End If
			If Not mysymbolmodel.LargeIcon Is Nothing Then
				lgImageIdx = Me.paletteGroupView1.AddLargeIcon(mysymbolmodel.LargeIcon)
			End If

			If Me.paletteGroupView1.SmallImageView Then
				imageIdx = smImageIdx
			Else
				imageIdx = lgImageIdx
			End If

			Dim gvItem As Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView.GroupViewPaletteItem = New PaletteGroupView.GroupViewPaletteItem(mysymbolmodel, imageIdx)
			Me.paletteGroupView1.GroupViewItems.Add(gvItem)

			' Initialize a SymbolModel for the custom Symbol class
			Dim mysymbolmodel1 As SymbolModel = Me.paletteGroupView1.Palette.AddSymbol("MyRectangle")
			mysymbolmodel1.PlugInClass = "Nested_Symbols.MyRectangle"
			mysymbolmodel1.PlugInAssembly = GetType(Form1).Assembly.FullName
			mysymbolmodel1.SmallIcon = New Bitmap("..\..\res\rectangle.jpg")
			mysymbolmodel1.LargeIcon = New Bitmap("..\..\res\rectangle.jpg")

			' Create a PaletteGroupView item to represent the SymbolModel and add it to the PaletteGroupView
			Dim imageIdx1 As Integer = 0
			Dim lgImageIdx1 As Integer= 0
			Dim smImageIdx1 As Integer= 0
			If Not mysymbolmodel1.SmallIcon Is Nothing Then
				smImageIdx1 = Me.paletteGroupView1.AddSmallIcon(mysymbolmodel1.SmallIcon)
			End If
			If Not mysymbolmodel1.LargeIcon Is Nothing Then
				lgImageIdx1 = Me.paletteGroupView1.AddLargeIcon(mysymbolmodel1.LargeIcon)
			End If

			If Me.paletteGroupView1.SmallImageView Then
				imageIdx1 = smImageIdx1
			Else
				imageIdx1 = lgImageIdx1
			End If

			Dim gvItem1 As Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView.GroupViewPaletteItem = New PaletteGroupView.GroupViewPaletteItem(mysymbolmodel1, imageIdx1)
			Me.paletteGroupView1.GroupViewItems.Add(gvItem1)

			' Initialize a SymbolModel for the custom Symbol class
			Dim mysymbolmodel2 As SymbolModel = Me.paletteGroupView1.Palette.AddSymbol("MyEllipse")
			mysymbolmodel2.PlugInClass = "Nested_Symbols.MyEllipse"
			mysymbolmodel2.PlugInAssembly = GetType(Form1).Assembly.FullName
			mysymbolmodel2.SmallIcon = New Bitmap("..\..\res\Ellipse.jpg")
			mysymbolmodel2.LargeIcon = New Bitmap("..\..\res\Ellipse.jpg")

			' Create a PaletteGroupView item to represent the SymbolModel and add it to the PaletteGroupView
			Dim imageIdx2 As Integer = 0
			Dim lgImageIdx2 As Integer = 0
			Dim smImageIdx2 As Integer = 0
			If Not mysymbolmodel.SmallIcon Is Nothing Then
				smImageIdx2 = Me.paletteGroupView1.AddSmallIcon(mysymbolmodel2.SmallIcon)
			End If
			If Not mysymbolmodel.LargeIcon Is Nothing Then
				lgImageIdx2 = Me.paletteGroupView1.AddLargeIcon(mysymbolmodel2.LargeIcon)
			End If

			If Me.paletteGroupView1.SmallImageView Then
				imageIdx2 = smImageIdx2
			Else
				imageIdx2 = lgImageIdx2
			End If

			Dim gvItem2 As Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView.GroupViewPaletteItem= New PaletteGroupView.GroupViewPaletteItem(mysymbolmodel2, imageIdx2)
			Me.paletteGroupView1.GroupViewItems.Add(gvItem2)
		End Sub


		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
			Me.paletteGroupView1 = New Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView()
			Me.diagram1 = New Syncfusion.Windows.Forms.Diagram.Controls.Diagram()
			Me.textBox1 = New System.Windows.Forms.TextBox()
			CType(Me.diagram1, System.ComponentModel.ISupportInitialize).BeginInit()
			CType(Me.diagram1.Model, System.ComponentModel.ISupportInitialize).BeginInit()
			Me.SuspendLayout()
			' 
			' paletteGroupView1
			' 
			Me.paletteGroupView1.ButtonView = True
			Me.paletteGroupView1.Dock = System.Windows.Forms.DockStyle.Left
			Me.paletteGroupView1.Location = New System.Drawing.Point(0, 0)
			Me.paletteGroupView1.Name = "paletteGroupView1"
			Me.paletteGroupView1.Size = New System.Drawing.Size(112, 430)
			Me.paletteGroupView1.TabIndex = 0
			Me.paletteGroupView1.Text = "paletteGroupView1"
			' 
			' diagram1
			' 
			Me.diagram1.AllowDrop = True
			' 
			' diagram1.Controller
			' 
			Me.diagram1.Controller.MaxHistory = 256
			Me.diagram1.Dock = System.Windows.Forms.DockStyle.Fill
			Me.diagram1.HScroll = True
			Me.diagram1.LayoutManager = Nothing
			Me.diagram1.Location = New System.Drawing.Point(112, 0)
			' 
			' diagram1.Model
			' 
			Me.diagram1.Model.BackgroundStyle.Color = System.Drawing.Color.White
			Me.diagram1.Model.BackgroundStyle.ForeColor = System.Drawing.Color.White
			Me.diagram1.Model.HeaderFooterData.Footer.Bounds.Width = 650F
			Me.diagram1.Model.HeaderFooterData.Header.Bounds.Width = 650F
			Me.diagram1.Model.MinimumSize = (CType(resources.GetObject("diagram1.Model.MinimumSize"), System.Drawing.SizeF))
			Me.diagram1.Model.Name = "Model"
			Me.diagram1.Model.ShadowStyle.AlphaFactor = 128
			Me.diagram1.Model.ShadowStyle.Color = System.Drawing.Color.LightGray
			Me.diagram1.Model.ShadowStyle.OffsetX = 6F
			Me.diagram1.Model.ShadowStyle.OffsetY = 6F
			Me.diagram1.Model.ShadowStyle.Visible = False
			Me.diagram1.Name = "diagram1"
			Me.diagram1.Size = New System.Drawing.Size(640, 430)
			Me.diagram1.SmartSizeBox = False
			Me.diagram1.TabIndex = 1
			Me.diagram1.Text = "diagram1"
			' 
			' diagram1.View
			' 
			Me.diagram1.View.Grid.Visible = False
			Me.diagram1.VScroll = True
'			Me.diagram1.NodeClick += New Syncfusion.Windows.Forms.Diagram.NodeMouseEventHandler(Me.diagram1_NodeClick);
			' 
			' textBox1
			' 
			Me.textBox1.BackColor = System.Drawing.Color.Lime
			Me.textBox1.Location = New System.Drawing.Point(376, 64)
			Me.textBox1.Name = "textBox1"
			Me.textBox1.Size = New System.Drawing.Size(144, 20)
			Me.textBox1.TabIndex = 2
			Me.textBox1.Text = ""
			' 
			' Form1
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
			Me.ClientSize = New System.Drawing.Size(752, 430)
			Me.Controls.Add(Me.textBox1)
			Me.Controls.Add(Me.diagram1)
			Me.Controls.Add(Me.paletteGroupView1)
			Me.Name = "Form1"
			Me.Text = "Form1"
'			Me.Load += New System.EventHandler(Me.Form1_Load);
			CType(Me.diagram1.Model, System.ComponentModel.ISupportInitialize).EndInit()
			CType(Me.diagram1, System.ComponentModel.ISupportInitialize).EndInit()
			Me.ResumeLayout(False)

		End Sub
		#End Region

		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main()
			Application.Run(New Form1())
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

			Dim insCmd As InsertNodesCmd = New InsertNodesCmd()

			'Add MyRectangle
			Dim rectangle As MyRectangle = New MyRectangle()
			rectangle.Bounds = New RectangleF(100,100,350,200)
			insCmd.Nodes.Add(rectangle)

			' Execute Insert command through the Diagram's Controller
			Me.diagram1.Controller.ExecuteCommand(insCmd)
			insCmd.Nodes.Clear()

			'Add MyEllipse and place it at the bottom right corner of the rectangle symbol.
			Dim ellipse As MyEllipse = New MyEllipse()
			ellipse.Bounds = New RectangleF(120, 120, 330, 180)
			insCmd.Nodes.Add(ellipse)

			' Execute Insert command through the Diagram's Controller
			Me.diagram1.Controller.ExecuteCommand(insCmd)
			insCmd.Nodes.Clear()

			Dim rrect As RoundedRectangle = New RoundedRectangle()
			rrect.Bounds = New RectangleF(180,170,200,70)
			insCmd.Nodes.Add(rrect)

			Me.diagram1.Controller.ExecuteCommand(insCmd)
			insCmd.Nodes.Clear()
		End Sub

		Private Sub diagram1_NodeClick(ByVal sender As Object, ByVal evtArgs As Syncfusion.Windows.Forms.Diagram.NodeMouseEventArgs) Handles diagram1.NodeClick
			Dim y As Integer=Me.diagram1.Model.GetChildIndex(evtArgs.Node)
			textBox1.Text="Index of Selected Node is"+" "+y.ToString()

			If TypeOf evtArgs.Node Is Symbol Then
				symbol=CType(IIf(TypeOf evtArgs.Node Is Symbol, evtArgs.Node, Nothing), Symbol)

				Select Case y
					Case 0
						symbol.FillStyle.Color=Color.Pink
					Case 1
						symbol.FillStyle.Color=Color.Lime

					Case 2
						symbol.FillStyle.Color=Color.SteelBlue

					Case Else
						symbol.FillStyle.Color=Color.LightSeaGreen
				End Select

			End If
		End Sub


	End Class
End Namespace
