#Region "Copyright Syncfusion Inc. 2001 - 2005"
'
'  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.ComponentModel
Imports System.Runtime.Serialization

Imports Syncfusion.Windows.Forms.Diagram

Namespace Nested_Symbols
	''' <summary>
	''' Summary description for MySymbol.
	''' </summary>
	<Serializable()> _
	Public Class MySymbol : Inherits Symbol
		Private outerRect As Syncfusion.Windows.Forms.Diagram.Rectangle = Nothing
		Private innerEllipse As Ellipse = Nothing

		Public Sub New()
			'////////////////////////////////////////////////////////////////
			' Add child nodes to the symbol programmatically
			'////////////////////////////////////////////////////////////////

			' Add an outer rectangle
			Me.outerRect = New Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 120, 80)
			Me.outerRect.Name = "Rectangle"
			Me.outerRect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient
			'this.outerRect.FillStyle.ForeColor = System.Drawing.Color.Orange;
			'this.outerRect.FillStyle.Color = Color.Orange;
			Me.outerRect.ShadowStyle.Visible = True
			Me.AppendChild(outerRect)

			' Add an inner ellipse at the bottom right corner of the Outer Rectangle
			Me.innerEllipse = New Ellipse(40, 40, 80, 40)
			Me.innerEllipse.Name = "Ellipse"
			'this.innerEllipse.FillStyle.Color = Color.Pink;
			Me.AppendChild(innerEllipse)

		End Sub
		''' <summary>
		''' Serialization constructor for symbols.
		''' </summary>
		''' <param name="info">Serialization state information</param>
		''' <param name="context">Streaming context information</param>
		Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
			MyBase.New(info, context)

		End Sub
		''' <summary>
		''' Populates a SerializationInfo with the data needed to
		''' serialize the target object.
		''' </summary>
		''' <param name="info">SerializationInfo object to populate</param>
		''' <param name="context">Destination streaming context</param>
		Protected Overrides Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext)
			MyBase.GetObjectData(info, context)

		End Sub
		''' <summary>
		''' Called when deserialization is complete.
		''' </summary>
		''' <param name="sender">Object performing the deserialization</param>
		Protected Overrides Sub OnDeserialization(ByVal sender As Object)
			MyBase.OnDeserialization(sender)
			' Get references to the child objects
			Me.outerRect = CType(IIf(TypeOf Me.GetChildByName("Rectangle") Is Syncfusion.Windows.Forms.Diagram.Rectangle, Me.GetChildByName("Rectangle"), Nothing), Syncfusion.Windows.Forms.Diagram.Rectangle)
			Me.innerEllipse = CType(IIf(TypeOf Me.GetChildByName("Ellipse") Is Ellipse, Me.GetChildByName("Ellipse"), Nothing), Ellipse)

		End Sub


	End Class
End Namespace
